library colorcombo;
uses
  Windows,
  messages;

type
Twin = record
host,combo,parent:hwnd;
proc:pointer;
did:integer;
end;

var
mhwnd,size,WC:integer;
wi:array[1..200] of TWin;
mDc,dc:hdc;
Bmp,xBmp:hBitmap;

type LoadInfo = packed record
mVersion: DWORD;
mHwnd: HWND;
mKeep: BOOL;
end;
PLoadInfo =  ^LoadInfo;

function Str2int(s:string) : integer;
var i,e:integer;
begin
val(s,i,e);
result:=i;
end;

function int2str(i:integer) : string;
var s:string;
begin
str(i,s);
result:=s;
end;

function smsg(const S: string):string;
var
MapFile:Integer;
Command:Pointer;
begin
MapFile:=CreateFileMapping(INVALID_HANDLE_VALUE, nil, PAGE_READWRITE, 0, 1024, 'mIRC');
Command:=MapViewOfFile(MapFile, FILE_MAP_ALL_ACCESS, 0, 0, 0);
lstrcpy(Command, PChar(S));
SendMessage(mhwnd,WM_USER+201,0,0);
result:=pchar(command);
UnmapViewOfFile(Command);
CloseHandle(MapFile);
end;

function GetTok(Str,Num,Tok:string):String;
begin
result:=smsg('$gettok('+str+','+num+','+tok+')');
end;

procedure LoadDll(Info: PLoadInfo); stdcall;
begin
dc:=GetDc(0);
mDc:=CreateCompatibleDc(dc);
Bmp:=CreateCompatibleBitmap(dc, GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN));
ReleaseDc(0,dc);
xbmp:=SelectObject(mDc,Bmp);
WC:=1;
Info.mKeep := true;
end;


function UnloadDll(mTimeout: Integer): Integer; stdcall;
var i:integer;
begin
result:=0;
if (mTimeout = 0) then begin
for i:=1 to wc do begin
SetWindowLong(wi[i].host,GWL_WNDPROC,LongInt(wi[i].proc));
end;
SelectObject(mDc,xbmp);
DeleteObject(bmp);
DeleteDc(mDc);
wc:=0;
result:=1;
end;
end;

function MakeRect(Left,Top,Right,Bottom:Integer ):TRect; stdcall;
begin
Result.Left := Left;
Result.Top  := Top;
Result.Right:= Right;
Result.Bottom := Bottom;
end;

function states(s,a:cardinal):boolean;
begin
result:=false;
if (a and ODA_FOCUS <> 0) and (s and ODS_SELECTED <> 0) and (s and ODS_FOCUS <> 0) then result:=true;
if (a and ODA_DRAWENTIRE <> 0) and (s and ODS_SELECTED <> 0) and (s and ODS_FOCUS <> 0) then result:=true;
end;

Function CmbProc(wnd:HWnd;msg:cardinal;wparam,lparam:LongInt):LongInt;stdcall;
var
Brush: hbrush;
e,col,x,y,w,h,i,q:integer;
DIS: PDrawItemStruct;
MIS: PMEASUREITEMSTRUCT;
r,p:trect;
Begin
Result := 0;
e:=0;
q:=1;
while (wnd <> wi[q].host) do q:=q+1;
if (msg = WM_MEASUREITEM) then begin
mis:=pointer(lparam);
mis.itemHeight:=size;
end
else if (msg = WM_DRAWITEM) then begin
e:=1;
DIS:=Pointer(lParam);
setbkmode(mDC,TRANSPARENT);
brush:=CreateSolidBrush(GetSysColor(COLOR_WINDOW));
fillrect(mDC,dis.rcItem,brush);
deleteobject(brush);
r:=dis.rcItem;
col:=str2int(smsg('$color('+int2str(dis.itemID-1)+')'));
if (dis.itemID = 0) then col:=GetSysColor(COLOR_WINDOW);
x:=r.Left+3;
y:=r.Top+2;
w:=r.right-3;
h:=r.Bottom-2;
p:=makerect(x,y,w,h);
setbkmode(mDC,TRANSPARENT);
brush:=CreateSolidBrush(rgb(127,127,127));
fillrect(mDC,p,brush);
deleteobject(brush);
r:=makerect(x+1,y+1,w-1,h-1);
brush:=CreateSolidBrush(col);
fillrect(mDC,r,brush);
deleteobject(brush);
if (dis.itemID = 0) then begin
brush:=CreateHatchBrush(HS_FDIAGONAL, rgb(127,127,127));
fillrect(mDC,r,brush);
deleteobject(brush);
end;
if (states(dis.itemState,dis.itemAction)) then begin
r:=makerect(x-1,y-1,w+1,h+1);
drawfocusrect(mDC,r);
end;
w:=dis.rcItem.Right-dis.rcItem.Left;
h:=dis.rcItem.Bottom-dis.rcItem.Top;
bitblt(dis.hDC,dis.rcItem.Left,dis.rcItem.Top,w,h,mDC,dis.rcItem.left,dis.rcItem.Top,SRCCOPY);
end
else if (msg = CB_SETCURSEL) and (lparam and 5000 = 0) then begin
SendMessage(wi[q].combo,CB_SETCURSEL,wparam,5000);
e:=0;
end
else if (MSG = WM_COMMAND) and (hiword(wParam) = 1) and (wnd = wi[q].host) then begin
e:=1;
i:=SendMessage(wi[q].combo,CB_GETCURSEL,0,0);
SendMessage(wi[q].host,CB_SETCURSEL,i,0);
SendMessage(wi[q].parent,WM_COMMAND,MakeLong(wi[q].did,CBN_SELCHANGE),wi[q].host);
end;
if (e = 0) then Result:=CallWindowProc(wi[q].proc,wnd,msg,wparam,lparam);
end;

FUNCTION COMBO(mWnd: hWnd; aWnd: hWnd; Data: pchar; Parms: PChar;
Show: Boolean; NoPause: Boolean ): Integer; export; stdcall;
var
s:String;
did,i:integer;
swnd,iwnd,cwnd:hwnd;
rec:trect;
begin
mhwnd:=mwnd;
s:='OK';
swnd:=str2int(smsg('$dialog('+Gettok(data,'1','32')+').hwnd'));
did:=Str2int(Gettok(data,'2','32'))+6000;
iwnd:=GetDlgItem(swnd,did);
for i:=1 to wc do begin
if (wc > 1) and (iwnd = wi[i].host) then S:='ERR';
end;
if not(iswindow(swnd)) or not(iswindow(iwnd)) or (wc > 200) then S:='ERR';;
if (S = 'OK') then begin
GetWindowRect(iwnd,rec);
i:=rec.Right-rec.Left;
size:=rec.Bottom-rec.Top-GetSystemMetrics(SM_CXFIXEDFRAME)*2;
wi[wc].parent:=swnd;
wi[wc].did:=did;
wi[wc].host:=iwnd;
wi[wc].proc:=pointer(SetWindowLong(iwnd,GWL_WNDPROC,longint(@cmbproc)));
cwnd:=CreateWindowEx(WS_EX_LEFT or WS_EX_LTRREADING or WS_EX_RIGHTSCROLLBAR , 'ComboBox','', WS_CHILD or WS_VISIBLE or
                     ws_tabstop or CBS_DROPDOWNLIST or cbs_hasstrings or cbs_ownerdrawfixed, 0, 0, i, 6000, iwnd, 0, 0, nil);
SendMessage(wi[wc].host,WM_SETREDRAW,0,0);
wi[wc].combo:=cwnd;
wc:=wc+1;
for i:=0 to 16 do begin
sendmessage(iwnd,CB_ADDSTRING,0,longint(pchar(Int2Str(i))));
sendmessage(cwnd,CB_ADDSTRING,0,longint(pchar(Int2Str(i))));
end;
end;
lstrcpy(data, pchar(s));
result:= 3;
end;

exports
LoadDll,
UnloadDll,
COMBO;

end.

